/*
 * nhWFX`FW[
 * 
 *  Copyright (c) 2010
 *  Panasonic System Networks Co., Ltd.
 *  All rights reserved.
 *
 * EAPI`wb_t@C
 *
 */

#ifndef MW_HGR_HGR_H_
#define MW_HGR_HGR_H_

#include <nn/types.h>

/*------------------------------------------------------------------------------------*/
#define		HGRCG_FINMAX		(   10 )			/* Fwő{				  */
#define		HGRCG_OBJMAX		(   32 )			/* F޼ުčő吔			  */
/*------------------------------------------------------------------------------------*/
#define		HGPAR_MODEMIN		(    0 )			/* F샂[hŏl			  */
#define		HGPAR_MODEMAX		(    2 )			/* F샂[hől			  */
/*------------------------------------------------------------------------------------*/
#define		HGPAR_NUMBMIN		(    1 )			/* w{wŏl				  */
#define		HGPAR_NUMBMAX		(   10 )			/* w{wől				  */
/*------------------------------------------------------------------------------------*/
#define		HGPAR_ANGLMIN		(    0 )			/* wpx͈͎wŏl			  */
#define		HGPAR_ANGLMAX		(    1 )			/* wpx͈͎wől			  */
/*------------------------------------------------------------------------------------*/
#define		HGPAR_LENGMIN		(   50 )			/* wŏlwŏl		  */
#define		HGPAR_LENGMAX		(  350 )			/* wŏlwől		  */
/*------------------------------------------------------------------------------------*/
#define		HGIMG_WIDMIN		(  320 )			/* 摜ŏl				  */
#define		HGIMG_WIDMAX		(  640 )			/* 摜ől				  */
#define		HGIMG_HEIMIN		(  240 )			/* 摜ŏl				  */
#define		HGIMG_HEIMAX		(  480 )			/* 摜ől				  */
/*------------------------------------------------------------------------------------*/
#define		HGEXT_RECTMIN		(  200 )			/* Ώۋ`̈扡ŏl */
/*------------------------------------------------------------------------------------*/

/*------------------------------------------------------------------------------------*/
#define		PSERR_TRUE			(    0 )			/* 						  */
#define		PSERR_MEMR			(   -1 )			/* s					  */
#define		PSERR_ARGU			(   -2 )			/* 						  */
#define		PSERR_IMAG			(   -3 )			/* 摜ُ						  */
#define		PSERR_PROC			(   -4 )			/* s\						  */
#define		PSERR_RECG			(   -5 )			/* Fs					  */
/*------------------------------------------------------------------------------------*/

namespace mw { namespace hgr {

typedef struct {

	u8			Z ;								/* _~[						  */
    u8			B ;								/* flΐ 				  */
    u8			G ;								/* flԐ 				  */
    u8			R ;								/* fl    				  */

} RGBColor;

typedef struct {

    s32			xSize  ;						/* 摜f[^				  */
    s32			ySize  ;						/* 摜f[^				  */
    RGBColor	*pcImg ;						/* J[摜f[^				  */

} PSCimg ;

typedef struct {

	u8			Y0 ;							/* Y( n )					  */
    u8			U  ;							/* U( n ) 					  */
    u8			Y1 ;							/* Y(n+1)					  */
    u8			V  ;							/* V( n )	   				  */

} YUVColor;

typedef struct {

    u32			xSize  ;						/* 摜f[^				  */
    u32			ySize  ;						/* 摜f[^				  */
    YUVColor	*pcImg ;						/* J[摜f[^				  */

} PSYUVimg ;

typedef struct {

    s32			x ;								/* _xW[f]				  */
    s32			y ;								/* _yW[f]				  */

} PSPoint ;

typedef struct {

	s32			sx ;							/* `̈Jn_xW[f]  */
	s32			sy ;							/* `̈Jn_yW[f]  */
	s32			ex ;							/* `̈I_ExW[f]  */
	s32			ey ;							/* `̈I_EyW[f]  */

} PSRect ;

typedef struct {

    u32         fingernum              ;		/* w{						  */
    PSPoint		fpoint[HGRCG_FINMAX]   ;		/* w[ʒu					  */
	u16			fdir[HGRCG_FINMAX]     ;		/* w(0`359)				  */
	s32			fleng[HGRCG_FINMAX]    ;		/* w						  */
	s32         reserve0               ;		/* \0						  */
	s32			reserve1               ;		/* \1						  */
	s32			reserve2               ;		/* \2						  */
	s32			reserve3               ;		/* \3						  */

} HGResult ;

typedef struct {

	s32			xsize    ;						/* 摜f[^ (320,640)		  */
	s32			ysize    ;						/* 摜f[^ (240,480)		  */
    PSRect		hgrect   ; 						/* Ώۋ`̈				  */
    s16         hgmode   ;						/* F샂[h (0,1)			  */
	s16			hgnumb   ;						/* wo{ (1`10)			  */
	s16			hganglflg;						/* wpx͈ (0:180deg,1:360deg) */
	s16			hgminleng;						/* wŏlw (50`350)	  */
    s16			hgmaxleng;						/* wőlw (50`350)	  */
    u8			reserve0 ;						/* \tO0					  */
    u8			reserve1 ;						/* \tO1					  */

} HGConfig ;

s32 		HGRcgGetWorkSize		( HGConfig*, u32*     ) ;
s32 		HGRcgProcessInit		( HGConfig*, u8*     ) ;
s32 		HGRcgProcessExec		( HGConfig*, PSYUVimg*, HGResult* ) ;


}}

#ifdef __cplusplus
extern "C" {
#endif

typedef struct {

    s32			x ;								/* _xW[f]				  */
    s32			y ;								/* _yW[f]				  */

} mwhgrPSPoint ;

typedef struct {

	s32			sx ;							/* `̈Jn_xW[f]  */
	s32			sy ;							/* `̈Jn_yW[f]  */
	s32			ex ;							/* `̈I_ExW[f]  */
	s32			ey ;							/* `̈I_EyW[f]  */

} mwhgrPSRect ;

typedef struct {

    u8			B ;								/* flΐ 				  */
    u8			G ;								/* flԐ 				  */
    u8			R ;								/* fl    				  */
	u8			Z ;								/* _~[						  */

} mwhgrRGBColor;

typedef struct {

    s32				xSize  ;					/* 摜f[^				  */
    s32				ySize  ;					/* 摜f[^				  */
    mwhgrRGBColor	*pcImg ;					/* J[摜f[^				  */

} mwhgrPSCimg ;

typedef struct {

	u8			Y0 ;							/* Y( n )					  */
    u8			U  ;							/* U( n ) 					  */
    u8			Y1 ;							/* Y(n+1)					  */
    u8			V  ;							/* V( n )	   				  */

} mwhgrYUVColor;

typedef struct {

    u32				xSize  ;					/* 摜f[^				  */
    u32				ySize  ;					/* 摜f[^				  */
    mwhgrYUVColor	*pcImg ;					/* J[摜f[^				  */

} mwhgrPSYUVimg ;


typedef struct {

    u32				bodynum                ;	/* ̐						  */
    mwhgrPSPoint	fpoint[HGRCG_FINMAX]   ;	/* w[ʒu					  */
	u16				fdir[HGRCG_FINMAX]     ;	/* w(0`359)				  */
	s32				fleng[HGRCG_FINMAX]    ;	/* w						  */
	s32				reserve0               ;	/* \0						  */
	s32				reserve1               ;	/* \1						  */
	s32				reserve2               ;	/* \2						  */
	s32				reserve3               ;	/* \3						  */

} mwhgrHGResult ;

typedef struct {

	s32				xsize    ;					/* 摜f[^ (320,640)		  */
	s32				ysize    ;					/* 摜f[^ (240,480)		  */
    mwhgrPSRect		hgrect   ; 					/* Ώۋ`̈				  */
    s16				hgmode   ;					/* F샂[h (0,1)			  */
	s16				hgnumb   ;					/* wo{ (1`10)			  */
	s16				hganglflg;					/* wpx͈ (0:180deg,1:360deg) */
	s16				hgminleng;					/* wŏlw (100`300)	  */
    s16				hgmaxleng;					/* wőlw (50`350)	  */
    u8				reserve0 ;					/* \tO0					  */
    u8				reserve1 ;					/* \tO1					  */

} mwhgrHGConfig ;

s32 	mwhgrHGRcgGetWorkSize		( mwhgrHGConfig*, u32*     ) ;
s32 	mwhgrHGRcgProcessInit		( mwhgrHGConfig*, u8*     ) ;
s32		mwhgrHGRcgProcessExec		( mwhgrHGConfig*, mwhgrPSYUVimg*, mwhgrHGResult* ) ;

#ifdef __cplusplus
}
#endif

#endif /* MW_HGR_HGR_H_ */

