// ----------------------------------------------------------------------
// Cj[NX
// ----------------------------------------------------------------------

// ----------------------------------------------------------------------
// include system header
// ----------------------------------------------------------------------
#include	<nn.h>
#include	<nn/gx.h>
#include	<nn/math.h>
#include	<nn/os.h>
#include	<nn/hid.h>
#include	<nn/fnd.h>
#include	<nn/fs.h>

#include	<string.h>

// ----------------------------------------------------------------------
// include original header
// ----------------------------------------------------------------------
#include	"CTR_Define.h"
#include	"CtrlGraphics.h"
#include	"CtrlCamera.h"
#include	"TxtWindow.h"
#include	"TxtWinMenu.h"

// ----------------------------------------------------------------------
// using namespace
// ----------------------------------------------------------------------
using namespace nn::hid;

typedef struct
{
	int hgmode;
	int hgnumb;
	int hganglflg;
	int hgminleng;
	int hgmaxleng;
}HGRLibParam, *LPHGRLibParam;

// ----------------------------------------------------------------------
// global
// ----------------------------------------------------------------------
static int g_quality	= 2;
static HGRLibParam g_HGRLibParam;

// ----------------------------------------------------------------------
// SetDrawQuality
// ----------------------------------------------------------------------
// e
//   `NIeB̕ύXs܂B
//   1F̂܂ܕ`
//   2Fc1/2ɂAg債ĕ`
//   3Fc1/4ɂAg債ĕ`
//   1̕掿3̕ɂȂ܂B
// ----------------------------------------------------------------------
// 
//   n		[ I ] ύX̃p[^w肵܂B
// ----------------------------------------------------------------------
// ߂l
//   
// ----------------------------------------------------------------------
void SetDrawQuality(int n)
{
	switch(n)
	{
	case 1:g_quality = 1;break;
	case 2:g_quality = 2;break;
	case 3:g_quality = 4;break;
	}
}

// ----------------------------------------------------------------------
// CTxtWinMenu::GetDrawQuality
// ----------------------------------------------------------------------
// e
//   `NIeB擾܂B
// ----------------------------------------------------------------------
// 
//   
// ----------------------------------------------------------------------
// ߂l
//   NIeBl(1,2,4)Ԃ܂B
// ----------------------------------------------------------------------
int CTxtWinMenu::GetDrawQuality()
{
	return g_quality;
}

// ----------------------------------------------------------------------
// SetHgMode/SetHgNumb/SetHgAnglFlg/SetHgMinLeng
// ----------------------------------------------------------------------
// e
//   HGRLibp[^̕ύXs܂B
// ----------------------------------------------------------------------
// 
//   n		[ I ] ύX̃p[^w肵܂B
// ----------------------------------------------------------------------
// ߂l
//   
// ----------------------------------------------------------------------
void SetHgMode   (int n) { g_HGRLibParam.hgmode    = n; }
void SetHgNumb   (int n) { g_HGRLibParam.hgnumb    = n; }
void SetHgAnglFlg(int n) { g_HGRLibParam.hganglflg = n; }
void SetHgMinLeng(int n) { g_HGRLibParam.hgminleng = n; }
void SetHgMaxLeng(int n) { g_HGRLibParam.hgmaxleng = n; }


// ----------------------------------------------------------------------
// CTxtWinMenu::GetHgMode/CTxtWinMenu::GetHgNumb/CTxtWinMenu::GetHgAnglFlg
// CTxtWinMenu::GetHgMinLeng/CTxtWinMenu::GetHgMaxLeng
// ----------------------------------------------------------------------
// e
//   HGRLibp[^̒l擾܂B
// ----------------------------------------------------------------------
// 
//   
// ----------------------------------------------------------------------
// ߂l
//   elԂ܂B
// ----------------------------------------------------------------------
int CTxtWinMenu::GetHgMode()	{ return g_HGRLibParam.hgmode;	 }
int CTxtWinMenu::GetHgNumb()	{ return g_HGRLibParam.hgnumb; }
int CTxtWinMenu::GetHgAnglFlg()	{ return g_HGRLibParam.hganglflg; }
int CTxtWinMenu::GetHgMinLeng()	{ return g_HGRLibParam.hgminleng; }
int CTxtWinMenu::GetHgMaxLeng()	{ return g_HGRLibParam.hgmaxleng; }

// ----------------------------------------------------------------------
// CTxtWinMenu::CTxtWinMenu
// ----------------------------------------------------------------------
// e
//   RXgN^
// ----------------------------------------------------------------------
// 
//   
// ----------------------------------------------------------------------
// ߂l
//   
// ----------------------------------------------------------------------
CTxtWinMenu::CTxtWinMenu()
	: CTxtWindow("Menu"),
	m_menu(3, "PROC SIZE"),
	m_menu_sa(3, "SETTING APPLICATION"),
	m_menu_sh(6, "SETTING HGRLIB"),
	m_menu_sc(9, "SETTING GESTURE")
{
	// ----------------------------------------------------------------------
	// Application Menu
	// ----------------------------------------------------------------------
	m_menu_sa.SetItemOnOff	(0, eMENU_T_SA_ENABLE,				"Hand Gesture       ", true, NULL);
	m_menu_sa.SetItemMinMax	(1, eMENU_T_SA_DRAWQUALITY,			"Draw Quality       ",  1,  3, 2, SetDrawQuality);
	m_menu_sa.SetItemExit	(2, eMENU_T_SA_EXIT,				"Exit               ", NULL);

	// ----------------------------------------------------------------------
	// HGRLib Menu
	// ----------------------------------------------------------------------
	m_menu_sh.SetItemMinMax	(0, eMENU_T_SH_HGMODE,				"HG Mode            ",   0,   2,   1, SetHgMode);
	m_menu_sh.SetItemMinMax	(1, eMENU_T_SH_HGNUMB,				"Numb   Param       ",   1,  10,  10, SetHgNumb);
	m_menu_sh.SetItemMinMax	(2, eMENU_T_SH_HGANGLFLG,			"Angle  Param       ",   0,   1,   0, SetHgAnglFlg);
	m_menu_sh.SetItemMinMax	(3, eMENU_T_SH_HGMINLENG,			"MinLen Param       ",  50, 350,  50, SetHgMinLeng, 10);
	m_menu_sh.SetItemMinMax	(4, eMENU_T_SH_HGMAXLENG,			"MaxLen Param       ",  50, 350, 350, SetHgMaxLeng, 10);
	m_menu_sh.SetItemExit	(5, eMENU_T_SH_EXIT,				"Exit               ", NULL);

	// ----------------------------------------------------------------------
	// Camera menu
	// ----------------------------------------------------------------------
	m_menu_sc.SetItemMinMax	(0, eMENU_T_SC_EXPOSURE,			"Exposure           ", -5,  5,  0, SetExporse);
	m_menu_sc.SetItemMinMax	(1, eMENU_T_SC_WHITEBALANCE,		"White Balance      ",  0,  5,  2, SetWhiteBalance);
	m_menu_sc.SetItemMinMax	(2, eMENU_T_SC_SHARPNESS,			"Sharpness          ", -4,  5,  0, SetSharpness);
	m_menu_sc.SetItemOnOff	(3, eMENU_T_SC_AUTOEXPOSURE,		"Auto Exposure      ", false,	  SetAutoExporse);
	m_menu_sc.SetItemOnOff	(4, eMENU_T_SC_AUTOWHITEBALANCE,	"Auto White Balance ", false,	  SetAutoWhiteBalance);
	m_menu_sc.SetItemMinMax	(5, eMENU_T_SC_PHOTOMODE,			"Photo Mode         ",  0,  4,  0, SetPhotoMode);
	m_menu_sc.SetItemMinMax	(6, eMENU_T_SC_CONTRAST,			"Contrast           ",  0, 10,  4, SetContrast);
	m_menu_sc.SetItemMinMax	(7, eMENU_T_SC_LENSCORRECTION,		"Lenscorrection     ",  0,  2,  1, SetLensCorrection);
	m_menu_sc.SetItemExit	(8, eMENU_T_SC_EXIT,				"Exit               ", NULL);

	m_menu_sc.SetItemStrFunc(eMENU_T_SC_PHOTOMODE,		GetPhotoModeStr);
	m_menu_sc.SetItemStrFunc(eMENU_T_SC_WHITEBALANCE,	GetWhiteBalanceStr);
	m_menu_sc.SetItemStrFunc(eMENU_T_SC_CONTRAST,		GetContrastStr);
	m_menu_sc.SetItemStrFunc(eMENU_T_SC_LENSCORRECTION,	GetLensCorrectionStr);

	// ----------------------------------------------------------------------
	// Root Menu
	// ----------------------------------------------------------------------
	m_menu.SetSubMenu(0, eMENU_T_SETTING_APPLICATION,	"Setting Application ", &m_menu_sa, NULL);
	m_menu.SetSubMenu(1, eMENU_T_SETTING_HGRLIB,		"Setting HGRLib      ", &m_menu_sh, NULL);
	m_menu.SetSubMenu(2, eMENU_T_SETTING_CAMERA,		"Setting Camera      ", &m_menu_sc, NULL);

	g_HGRLibParam.hgmode	= 1;
	g_HGRLibParam.hgnumb	= 10;
	g_HGRLibParam.hganglflg	= 0;
	g_HGRLibParam.hgminleng	= 50;
	g_HGRLibParam.hgmaxleng	= 350;
}

// ----------------------------------------------------------------------
// CTxtWinMenu::~CTxtWinMenu
// ----------------------------------------------------------------------
// e
//   fXgN^
// ----------------------------------------------------------------------
// 
//   
// ----------------------------------------------------------------------
// ߂l
//   
// ----------------------------------------------------------------------
CTxtWinMenu::~CTxtWinMenu()
{
}

// ----------------------------------------------------------------------
// CTxtWinMenu::Draw
// ----------------------------------------------------------------------
// e
//   Window̕\s܂B
// ----------------------------------------------------------------------
// 
//   graphics		[ I ] OtBbNNXw肵܂B
//   display		[ I ] Window\fBXvCw肵܂B
//   sx				[ I ] Window\XWw肵܂B
//   sy				[ I ] Window\YWw肵܂B
// ----------------------------------------------------------------------
// ߂l
//   0Ԃ܂B
// ----------------------------------------------------------------------
int CTxtWinMenu::Draw(CCtrlGraphics* graphics, const s32 display, int sx, int sy)
{
	char	str[64];
	int		n		 = 0;
	int		menu_num = m_menu.GetCount();

	CTxtWindow::SetLines(menu_num);
	for (n = 0 ; n < menu_num ; n++)
	{
		m_menu.GetItemText(n, str);
		CTxtWindow::SetText(n, str, 0.0, 0.0, 0.0);
	}

	CTxtWindow::DrawWindow(graphics, display, sx, sy);

	return 0;
}

// ----------------------------------------------------------------------
// CTxtWinMenu::IsEnableHandGesture
// ----------------------------------------------------------------------
// e
//   nhWFX`[ONOFF擾܂B
// ----------------------------------------------------------------------
// 
//   
// ----------------------------------------------------------------------
// ߂l
//   ON̏ꍇtrueԂAOFF̏ꍇfalseԂ܂B
// ----------------------------------------------------------------------
bool CTxtWinMenu::IsEnableHandGesture()
{
	return m_menu_sa.GetItemOnOff(eMENU_T_SA_ENABLE);
}

// ----------------------------------------------------------------------
// CTxtWinMenu::Ctrl
// ----------------------------------------------------------------------
// e
//   pbhɂ鑀s܂B
//   E{^F̍ڂɈړ܂B
//   E{^F̍ڂɈړ܂B
//   EA {^F肩Al{܂B
//   EB {^F肩Al|܂B
// ----------------------------------------------------------------------
// 
//   padStatus			[ I ] pbh̏Ԃw肵܂B
// ----------------------------------------------------------------------
// ߂l
//   
// ----------------------------------------------------------------------
void CTxtWinMenu::Ctrl(PadStatus* padStatus)
{
	// ----------------------------------------------------------------------
	//  {^
	// ----------------------------------------------------------------------
	if (padStatus->trigger & BUTTON_UP)
	{
		m_menu.SetPrev();
	}

	// ----------------------------------------------------------------------
	//  {^
	// ----------------------------------------------------------------------
	if (padStatus->trigger & BUTTON_DOWN)
	{
		m_menu.SetNext();
	}

	// ----------------------------------------------------------------------
	// A {^ ivXj
	// ----------------------------------------------------------------------
	if (padStatus->trigger & BUTTON_A)
	{
		m_menu.SetSelect(true);
	}

	// ----------------------------------------------------------------------
	// B {^ i}CiXj
	// ----------------------------------------------------------------------
	if (padStatus->trigger & BUTTON_B)
	{
		m_menu.SetSelect(false);
	}
}
