//**************************************************************************************
//
//		Hand Gesture Recognition Library (HGRLib)
//
//		HGRLib Native Source File
//
//		Copyright   :: (C) PANASNOIC CORPORATION, SYSTEM NETWORKS COMPANY 2010
//		Date        :: 2010.03.23
//		CPU         :: **
//		Language    :: C,C++
//		File Name   :: demo.cpp
//
//**************************************************************************************

// ----------------------------------------------------------------------
// define
// ----------------------------------------------------------------------
#define		CPLUSPLUS

// ----------------------------------------------------------------------
// include system header
// ----------------------------------------------------------------------
#include	<nn.h>
#include	<nn/os.h>
#include	<nn/fs.h>
#include	<nn/fnd.h>
#include	<nn/hid.h>
#include	<nn/math.h>
#include	<nn/hid.h>
#include	<nn/camera.h>
#include	<nn/y2r.h>
#include	<nn/hid.h>
#include	<nn/applet.h>

// ----------------------------------------------------------------------
// include hgr header
// ----------------------------------------------------------------------
#include	"hgr.h"					// hgrwb_[
using namespace mw::hgr;

// ----------------------------------------------------------------------
// include original header
// ----------------------------------------------------------------------
#include	"CTR_Define.h"
#include	"CtrlGraphics.h"
#include	"CtrlCamera.h"
#include	"TxtMenu.h"
#include	"TxtWindow.h"
#include	"TxtWinStartup.h"
#include	"TxtWinMenu.h"
#include	"TxtWinResultHgr.h"
#include	"TxtWinDebugTimer.h"
#include	"DebugWriterHgr.h"
#include	"appdefine.h"

// ----------------------------------------------------------------------
// using namespace
// ----------------------------------------------------------------------
using namespace nn::hid;
using namespace nn::os;
using namespace nn::math;

// ----------------------------------------------------------------------
// global
// ----------------------------------------------------------------------
extern nn::fnd::ExpHeap gAppHeap;
static u8 *rgbBuffer;
static u8 *yuvBuffer;

// ----------------------------------------------------------------------
// nnMain
// ----------------------------------------------------------------------
void nnMain(void)
{
	unsigned char	*extBuf			= NULL;
	u32				workSize		= 0;
	HGConfig		hgConfig;

	PSYUVimg		hgYUVimg;

	HGResult		hgResult;
	int				fingernum		= 0;
	PSPoint			*fpoint			= NULL;
	unsigned short	*fdir			= NULL;

	int 			n				= 0;
	int				i				= 0;
	int				ret				= 0;

	int				proc_width		= 320;				// Ŝ̕ 摜́`` iFj
	int				proc_height		= 240;				// Ŝ̍ 摜́`` iFj
	Size			proc_size		= SIZE_QVGA;
	FrameRate		proc_rate		= FRAME_RATE_30;

	int				view_width		= nn::gx::CTR::DISPLAY1_HEIGHT;		// J摜\View̕   (DISPLAY1_HEIGHT = 320) 
	int				view_height		= nn::gx::CTR::DISPLAY1_WIDTH;		// J摜\View̍ (DISPLAY1_WIDTH = 240)

	int				hgr_width		= 160;				// F摜
	int				hgr_height		= 120;				// F摜

	int				txtWinSort		= 0;

	CCtrlGraphics	graphics;					// OtBbNNX
	CCtrlCamera		camera;						// JNX

	// Window class
	CTxtWinStartup			startWnd;			// NWindow
	CTxtWinMenu				menuWnd;			// j[Window
	CTxtWinResultHgr		resultWnd;			// Window
	CTxtWinDebugTimer		dbgTimerWnd(8);		// fobO^C}[\Window

	CDebugWriterHgr	dbgWriter;			// fobOo
	bool			dbg_init		= false;	

	char str[64];

	// ======================================================================

	PRINT_OUT("Demo Start\n");

    nn::Result result;

    // fs ̏
    nn::fs::Initialize();

    // hid ̏
    result = nn::hid::Initialize();
    NN_UTIL_PANIC_IF_FAILED(result);

    // z[j[sł悤 nn::applet::Enable() ̂݌Ă
    // z[j[Jڂd{^NbNAX[vɂ͔Ή
    nn::applet::Enable();

	// pbh
	PadReader		padReader;
	PadStatus		padStatus;

	OS_MEM_INIT();
	FILE_IO_INIT();
	OS_TICK_INIT();

 	// ----------------------------------------------------------------------
	// OtBbNNX̏
	// ----------------------------------------------------------------------
	graphics.InitializeGraphics();

 	// ----------------------------------------------------------------------
	// NWindow\AVGA[hQVGA[hI
	// ----------------------------------------------------------------------
	startWnd.DoModal(&graphics, NN_GX_DISPLAY1, -1, -1);
	
	eSTART_MODE eStartMode = startWnd.GetStartMode();

	if (eStartMode == eSTART_VGA)
	{
		proc_width		= 640;				// ͉摜/`摜
		proc_height		= 480;				// ͉摜/`摜
		proc_size		= SIZE_VGA;			// ̓TCY
		proc_rate		= FRAME_RATE_20;	// ̓t[[g
		hgr_width		= 640;				// F摜
		hgr_height		= 480;				// F摜
	}
	else if (eStartMode == eSTART_QVGA)
	{
		proc_width		= 320;				// ͉摜/`摜
		proc_height		= 240;				// ͉摜/`摜
		proc_size		= SIZE_QVGA;		// ̓TCY
		proc_rate		= FRAME_RATE_30;	// ̓t[[g
		hgr_width		= 320;				// F摜
		hgr_height		= 240;				// F摜
	}

 	// ----------------------------------------------------------------------
	// JNX̏
 	// ----------------------------------------------------------------------
	camera.InitializeCamera(SELECT_IN1, proc_size, proc_rate);

	dbgTimerWnd.SetTimerText(0, "recv camera    ");
	dbgTimerWnd.SetTimerText(1, "create cimg    ");
	dbgTimerWnd.SetTimerText(2, "proc exec      ");
	dbgTimerWnd.SetTimerText(3, "draw disp0     ");
	dbgTimerWnd.SetTimerText(4, "create texture ");
	dbgTimerWnd.SetTimerText(5, "draw disp1     ");
	dbgTimerWnd.SetTimerText(6, "other          ");
	dbgTimerWnd.SetTimerText(7, "swap buffer    ");

	// ----------------------------------------------------------------------
	// ݒ
	// ----------------------------------------------------------------------
	hgConfig.xsize		= hgr_width;				// 摜f[^ (320,640)
	hgConfig.ysize		= hgr_height;				// 摜f[^ (240,480)
	hgConfig.hgrect.sx	= 0;						// Ώۋ`̈
	hgConfig.hgrect.sy	= 0;						// Ώۋ`̈
	hgConfig.hgrect.ex	= hgr_width - 1;			// Ώۋ`̈
	hgConfig.hgrect.ey	= hgr_height - 1;			// Ώۋ`̈
	hgConfig.hgmode		= 1;						// F샂[h		(0, 1)
	hgConfig.hgnumb		= 10;						// wo{ (1`10)
	hgConfig.hganglflg	= 0;						// wpx͈ (0:180deg,1:360deg)
	hgConfig.hgminleng	= 50;						// wŏlw (50`350)
	hgConfig.hgmaxleng	= 350;						// wőlw (50`350)
	hgConfig.reserve0	= 0;						// \tO0
	hgConfig.reserve1	= 0;						// \tO1

	// ----------------------------------------------------------------------
	// Cu֐FKvƗ̈TCY̎擾
	// ----------------------------------------------------------------------
	ret = HGRcgGetWorkSize(&hgConfig, &workSize);
	if (ret != PSERR_TRUE)
	{
		PRINT_OUT("HGRcgGetWorkSize NG\n");
		return;
	}
	PRINT_OUT("HGRcgGetWorkSize OK[%ld]\n", workSize);

	extBuf = (u8*)OS_MALLOC(workSize);
	if (extBuf == NULL)
	{
		PRINT_OUT("malloc extBuf NG\n");
		return;
	}

    rgbBuffer = (u8*)OS_MALLOC_EX( 640 * 480 * 4, 64 );
    yuvBuffer = (u8*)OS_MALLOC_EX( 640 * 480 * 2, 64 );

	hgYUVimg.xSize = proc_width;
	hgYUVimg.ySize = proc_height;
	hgYUVimg.pcImg = (YUVColor*)yuvBuffer;

	// ----------------------------------------------------------------------
	// Cu֐F
	// ----------------------------------------------------------------------
	ret = HGRcgProcessInit(&hgConfig, extBuf);
	if (ret != PSERR_TRUE)
	{
		PRINT_OUT("HGRcgProcessInit NG\n");
		OS_FREE(extBuf);
		return;
	}
	PRINT_OUT("HGRcgProcessInit OK\n");

	// ----------------------------------------------------------------------
	// eWindow̐ݒ
	// ----------------------------------------------------------------------
	menuWnd.SetWindowWidth(nn::gx::DISPLAY0_HEIGHT);

	resultWnd.SetWindowWidth(306);
	resultWnd.SetWindowHeight(120);

	menuWnd.SetForcus(true);

	// ----------------------------------------------------------------------
	// C[v
	// ----------------------------------------------------------------------
	int frame	 = 0;
	while(1)
	{
		dbgTimerWnd.TimerAllStart();

		// ----------------------------------------------------------------------
		// J̃f[^擾
		// ----------------------------------------------------------------------
		camera.Receive(rgbBuffer,yuvBuffer, dbgTimerWnd);

		// ----------------------------------------------------------------------
		// PSCimg쐬 (オ(0, 0)ł邽ߏ㉺]) 
		// 2011.06.16 YUVΉɂsvɂȂ폜
		// ----------------------------------------------------------------------
		dbgTimerWnd.TimerStart(1);
		if (menuWnd.IsEnableHandGesture() == true)
		{
		}
		dbgTimerWnd.TimerEnd(1);

		// ----------------------------------------------------------------------
		// F
		// ----------------------------------------------------------------------
		hgResult.fingernum	= 0;
		for (i = 0 ; i < HGRCG_FINMAX ; i++)
		{
			hgResult.fpoint[i].x = 0;
			hgResult.fpoint[i].y = 0;
			hgResult.fdir[i] = 0;
			hgResult.fleng[i] = 0;
		}
		hgResult.reserve0	= 0;
		hgResult.reserve1	= 0;
		hgResult.reserve2	= 0;
		hgResult.reserve3	= 0;

		hgConfig.hgmode		= menuWnd.GetHgMode();
		hgConfig.hgnumb		= menuWnd.GetHgNumb();
		hgConfig.hganglflg	= menuWnd.GetHgAnglFlg();
		hgConfig.hgminleng	= menuWnd.GetHgMinLeng();
		hgConfig.hgmaxleng	= menuWnd.GetHgMaxLeng();
		dbgTimerWnd.TimerStart(2);
		if (menuWnd.IsEnableHandGesture() == true)
		{
			// ----------------------------------------------------------------------
			// Cu֐FF̎s
			// ----------------------------------------------------------------------
			ret = HGRcgProcessExec(&hgConfig, &hgYUVimg, &hgResult);
		}
		dbgTimerWnd.TimerEnd(2);

		fingernum	= hgResult.fingernum;
		fpoint		= hgResult.fpoint;

		// ======================================================================
		// 
		// ======================================================================
		dbgTimerWnd.TimerStart(3);
		graphics.ClearDisplay(NN_GX_DISPLAY0);

		// ----------------------------------------------------------------------
		// Fʂݒ
		// ----------------------------------------------------------------------
		resultWnd.UpdateResult(&hgResult);

		// ----------------------------------------------------------------------
		// Window`
		// ----------------------------------------------------------------------
		for (n = txtWinSort ; n < txtWinSort + 3 ; n++)
		{
			switch((n + 1) % 3)
			{
			case 0: menuWnd.Draw	(&graphics, NN_GX_DISPLAY0,   0,  0);	break;
			case 1: resultWnd.Draw	(&graphics, NN_GX_DISPLAY0,  40, 80);	break;
			case 2:	dbgTimerWnd.Draw(&graphics, NN_GX_DISPLAY0,  10, 60);	break;
			}
		}

		// ----------------------------------------------------------------------
		// EɃt[`
		// ----------------------------------------------------------------------
		sprintf(str, "frame:[%08d]\n", frame++);
		graphics.SetColor(NN_GX_DISPLAY0, 0.0, 1.0, 0.0);
		graphics.DrawTextEx(NN_GX_DISPLAY0, 272, 214, str);

		// ----------------------------------------------------------------------
		// Swap
		// ----------------------------------------------------------------------
		graphics.SwapBuffer(NN_GX_DISPLAY0);

		dbgTimerWnd.TimerEnd(3);

		// ======================================================================
		// fBXvC
		// ======================================================================

		// ----------------------------------------------------------------------
		// `eNX`[̐
		// ----------------------------------------------------------------------
		u32 bmpWidth		= proc_width;
		u32 bmpHeight		= proc_height;
		u32 textureWidth	= 0;
		u32 textureHeight	= 0;

		dbgTimerWnd.TimerStart(4);
		int quality = menuWnd.GetDrawQuality();
		u8* texBuffer = graphics.GetTextureDataFromBmpFileData(bmpWidth, bmpHeight, rgbBuffer, textureWidth, textureHeight, quality);
		dbgTimerWnd.TimerEnd(4);

		// ----------------------------------------------------------------------
		// `
		// ----------------------------------------------------------------------
		dbgTimerWnd.TimerStart(5);
		graphics.ClearDisplay(NN_GX_DISPLAY1);
		graphics.DrawCamera(texBuffer, textureWidth, textureHeight, bmpWidth, bmpHeight, quality);
		dbgTimerWnd.TimerEnd(5);

		graphics.DrawDateTime();
		dbgTimerWnd.TimerStart(6);

		// ----------------------------------------------------------------------
		// Fʂ̕`
		// ----------------------------------------------------------------------
		fpoint	= hgResult.fpoint ;
		fdir	= hgResult.fdir;
		for (n = 0 ; n < fingernum ; n++ )
		{
			// Jn_
			float sx	= (float)fpoint->x * ((float)view_width  / (float)proc_width);
			float sy	= (float)fpoint->y * ((float)view_height / (float)proc_height);

			// 
			float dir	= (short) * fdir + 180.0f;
			dir -= (dir > 360.0f) ? 360.0f : 0.0f;
			dir += (dir < 0.0f  ) ? 360.0f : 0.0f;

			// I_
			float ex	= sx + 30.0f * nn::math::CosFIdx(dir / 360.0f * 256.0f);
			float ey	= sy - 30.0f * nn::math::SinFIdx(dir / 360.0f * 256.0f);

			// 
			float ldir = dir + 135.0f;
			float rdir = dir - 135.0f;

			ldir -= (ldir > 360.0f) ? 360.0f : 0.0f;
			ldir += (ldir < 0.0f  ) ? 360.0f : 0.0f;

			rdir -= (rdir > 360.0f) ? 360.0f : 0.0f;
			rdir += (rdir < 0.0f  ) ? 360.0f : 0.0f;

			float alx	= ex + 10.0f * nn::math::CosFIdx(ldir / 360.0f * 256.0f);
			float aly	= ey - 10.0f * nn::math::SinFIdx(ldir / 360.0f * 256.0f);
			float arx	= ex + 10.0f * nn::math::CosFIdx(rdir / 360.0f * 256.0f);
			float ary	= ey - 10.0f * nn::math::SinFIdx(rdir / 360.0f * 256.0f);

			graphics.SetColor(NN_GX_DISPLAY1, 1.0, 0.0, 0.0);
			graphics.DrawLine(NN_GX_DISPLAY1, sx, sy, ex, ey);
			graphics.DrawLine(NN_GX_DISPLAY1, ex, ey, alx, aly);
			graphics.DrawLine(NN_GX_DISPLAY1, ex, ey, arx, ary);
			fpoint++;
			fdir++;
		}

		// ----------------------------------------------------------------------
		// Rg[[̑ɂ郁j[̑
		// ----------------------------------------------------------------------
		// LR{^WindowI
		// ㉺{^ōڂ̑
		// AB{^Œl̕ύX
		// X{^SDo
		// Y{^ŏI
		// ----------------------------------------------------------------------
		padReader.ReadLatest(&padStatus);

		if (txtWinSort == 0)
		{
			menuWnd.Ctrl(&padStatus);
		}

		// L Button i}CiXj
		if (padStatus.trigger & BUTTON_L)
		{
			txtWinSort -= (txtWinSort > 0) ? 1 : -2;
		}

		// R Button ivXj
		if (padStatus.trigger & BUTTON_R)
		{
			txtWinSort += (txtWinSort < 2) ? 1 : -2;
		}

		// tH[JX̐؂ւ
		menuWnd.SetForcus(txtWinSort == 0);
		resultWnd.SetForcus(txtWinSort == 1);
		dbgTimerWnd.SetForcus(txtWinSort == 2);

		// X Button SDɏo
		if (padStatus.trigger & BUTTON_X)
		{
			if (dbg_init == false)
			{
				dbg_init = dbgWriter.Initialize();
			}

			// ɐĂꍇ̂ݏo
			if (dbg_init == true)
			{
				dbgWriter.Output(rgbBuffer, proc_width, proc_height, &hgResult);
			}
		}

		// Y Button ŏI
		if (padStatus.trigger & BUTTON_Y)
		{
			break;
		}

		dbgTimerWnd.TimerEnd(6);

		// ----------------------------------------------------------------------
		// Swap
		// ----------------------------------------------------------------------
		dbgTimerWnd.TimerStart(7);
		graphics.SwapBuffer(NN_GX_DISPLAY1);
		dbgTimerWnd.TimerEnd(7);

		// ----------------------------------------------------------------------
		// wait vsync
		// ----------------------------------------------------------------------
		graphics.WaitVsync();
		dbgTimerWnd.TimerAllEnd();
	}

	///////////////////////////
	///////////////////////////
	///////////////////////////
	// Free all memory areas.
	///////////////////////////
	///////////////////////////
	///////////////////////////
    OS_FREE( rgbBuffer );
    OS_FREE( yuvBuffer );

	if (extBuf != NULL)
	{
		OS_FREE(extBuf);
		extBuf = NULL;
	}

	graphics.FinalizeGraphics();
	camera.FinalizeCamera();

	// hid ̔j
	nn::hid::Finalize();

	FILE_IO_TERM();
	OS_MEM_TERM();

	//////////////////
	//////////////////
	//////////////////
	// Return .
	//////////////////
	//////////////////
	//////////////////
	PRINT_OUT("Program END\n");

	return ;
}

//	End of File ////////////////////////////////////////////////////////////////////////
